unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, memds, Forms, Controls, Graphics, Dialogs, DBGrids,
  DBCtrls, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DBNavigator1: TDBNavigator;
    ds_mdsTemplate: TDataSource;
    DBGrid1: TDBGrid;
    mdsTemplate: TMemDataset;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMemTable;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  InitMemTable;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitMemTable;
end;

procedure TForm1.InitMemTable;
begin
  if mdsTemplate.Active then
    mdsTemplate.Close;

  mdsTemplate.Clear; //Daten und Struktur löschen

  mdsTemplate.FieldDefs.Add('typbezeichnung', ftString, 30);
  mdsTemplate.FieldDefs.Add('preis_vom', ftDate);
  mdsTemplate.FieldDefs.Add('typEKnetto', ftCurrency, 10);
  mdsTemplate.FieldDefs.Add('typsortierung', ftInteger, 5);


  //POS1   hier muss das richtige Feldformat gewählt werden
  //       gewünscht ist eines das einem DECIMAL 5,2  von MariaDB entpricht
  mdsTemplate.FieldDefs.Add('Anzahl', ftFloat);



  if not mdsTemplate.Active then
    mdsTemplate.Open;


  with mdsTemplate.FieldByName('Anzahl') do
   begin
     DisplayLabel := 'Anzahl';
     ReadOnly := False;
     Visible := True;
     DisplayWidth := 10;

     //POS2   hier ist evtl die richtige Editmask nötig
     //       diese verhält sich für mich komisch
     EditMask:='0,000';
   end;

  with mdsTemplate.FieldByName('typbezeichnung') do
  begin
    DisplayLabel := 'Typ';
    ReadOnly := True;
    Visible := True;
    DisplayWidth := 25;
  end;

  with mdsTemplate.FieldByName('typEKnetto') do
  begin
    DisplayLabel := 'Typ';
    ReadOnly := True;
    Visible := False;
    DisplayWidth := 10;
  end;

  with mdsTemplate.FieldByName('typsortierung') do
  begin
    DisplayLabel := 'Sortierung';
    ReadOnly := True;
    Visible := False;
    DisplayWidth := 10;
  end;

  mdsTemplate.DisableControls;
  mdsTemplate.Insert;
  mdsTemplate.FieldByName('typbezeichnung').AsString:='Typ 1';
  mdsTemplate.FieldByName('preis_vom').AsDateTime:=now;

  mdsTemplate.Insert;
  mdsTemplate.FieldByName('typbezeichnung').AsString:='Typ 2';
  mdsTemplate.FieldByName('preis_vom').AsDateTime:=now;

  mdsTemplate.Post;
  mdsTemplate.First;
  mdstemplate.EnableControls;
end;

end.

